import os
import webbrowser
import subprocess
import json
import time

PKG_PATH = os.path.dirname(os.path.dirname(__file__))

config_path = os.path.join(PKG_PATH, "config.json")

with open(config_path, "r", encoding='utf-8') as fo:
    config = json.load(fo)

sh = {
    "cd": "{0} && cd {1} ".format(config["disk"], config["blog_path"]),
    "generate": "hexo g",
    "deploy": "hexo g -d",
    "server": "hexo server",
    "clean": "hexo clean",
    "explorer": "explorer",
}


def mCmd(iterable):
    """os.system()执行多条指令
    """
    return subprocess.Popen("&& ".join(iterable), shell=True)


def startServer(port=4000):
    cmd = [
        sh["cd"],
        "{0} -p {1}".format(sh["server"], port),
    ]
    popen = mCmd(cmd)
    time.sleep(4)
    webbrowser.open("http://localhost:{1}".format(sh["explorer"], port))
    return popen


def stopNodeProcess(pid):
    if os.system('taskkill /pid {0} /f'.format(pid)) in (0, 1) and os.system(
            'taskkill /F /IM node.exe'.format(pid)) in (0, 1):
        return True
    else:
        return False


def deploy():
    cmd = [
        sh["cd"],
        sh["deploy"],
    ]
    mCmd(cmd)


def executeCommand(command, *args):
    try:
        with open(config_path, "r", encoding='utf-8') as fo:
            config = json.load(fo)
        print("Run_CWD: {0}...".format(config["cwd"]))
        sp = subprocess.Popen(command,
                              shell=True,
                              stdout=subprocess.PIPE,
                              stderr=subprocess.PIPE,
                              cwd=config["cwd"])
        out, err = sp.communicate()
        if out:
            print(out.decode("gbk"))
        if err:
            print(err.decode("gbk"))
    except BaseException as e:
        print(e)


def webReadme():
    webbrowser.open("https://github.com/ShoorDay/HexoTools")


# if __name__ == "__main__":
#     startServer()